#include<bits/stdc++.h>
using namespace std;
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

typedef unsigned long long ull;
typedef long long ll;       
typedef pair<int, int> pi;


int n;
int x[100000], y[100000];
long long ans[100000];

long long dist(int a, int b) {
    return ((ll)x[a] - x[b]) * (x[a] - x[b]) + ((ll)y[a] - y[b]) * (y[a] - y[b]);
}
int can[100000];

int check(ll l) {
    vector<int> st;
    for (int i = 0; i < n; ++i)
        can[i] = 0;
    can[0] = 1;
    st.push_back(0);
    for (int i = 1; i < n; ++i) {
        while (st.size() > 0 && y[st.back()] <= y[i]) {
            can[i] |= (can[st.back()] > 0 && (dist(st.back(), i) <= l));
            st.pop_back();
        }
        if (st.size() > 0) 
            can[i] |= can[st.back()] && dist(st.back(), i) <= l;
        st.push_back(i);
    }
    return can[n - 1];

}

int main() {
    freopen("icebergs.in", "r", stdin);
    freopen("icebergs.out", "w", stdout);    
    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d%d", &x[i], &y[i]);
    vector<int> st;
    ll l = 0, r = 4000000000000000000LL;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    cerr << check(1);

    printf("%1.7lf", sqrt(r));
    return 0;
}
